local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/MapHeightIronMountain.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_c.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_IronMountain_2020",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -15,
	MaxHeight = 72,
	VillagePathList = {
		{
			Entrance = { 1015, 0, 411 },
			Exit = { 1015, 0, 411 }
		},
		{
			Entrance = { 1015, 0, 622 },
			Exit = { 1015, 0, 622 }
		},
		{
			Entrance = { 900, 0, 1018 },
			Exit = { 900, 0, 1018 }
		},
		{
			Entrance = { 705, 0, 20 },
			Exit = { 705, 0, 20 }
		},
		{
			Entrance = { 802, 0, 1015 },
			Exit = { 802, 0, 1015 }
		},
		{
			Entrance = { 1015, 0, 155 },
			Exit = { 1015, 0, 155 }
		}
	},
	SpawnList = {
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 102, 34, 649 },
			Orientation = { 0.0, 1.8, 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 160, 45, 688 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 166, 35, 438 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 132, 44, 424 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 212, 43, 416 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 205, 15, 549 },
			Orientation = { 0.0, 1.5, 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 118, 38, 849 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 147, 37, 196 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 187, 23, 202 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 202, 41, 654 },
			Orientation = { 0.0, -2.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 200, 45, 665 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 207, 47, 655 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 197, 42, 670 },
			Orientation = { 0.0, -1.6, 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 111, 29, 515 },
			Orientation = { 0.0, 0.6, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 100, 35, 532 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 100, 35, 514 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 108, 31, 527 },
			Orientation = { 0.0, 0.4, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 104, 32, 537 },
			Orientation = { 0.0, 0.1, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 84, 35, 530 },
			Orientation = { 0.0, 0.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 92, 36, 502 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 105, 32, 504 },
			Orientation = { 0.0, 1.0, 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 221, 5, 774 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 220, 7, 798 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 291, 16, 558 },
			Orientation = { 0.0, 2.2, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 280, 14, 550 },
			Orientation = { 0.0, 2.9, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 272, 21, 564 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 272, 17, 557 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 265, 14, 550 },
			Orientation = { 0.0, 3.1, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 260, 19, 555 },
			Orientation = { 0.0, math.randomf(-4, 4), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 255, 15, 546 },
			Orientation = { 0.0, 2.6, 0.0 }
		},


		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 214, 38, 630 },
			Orientation = { 0.0, 3.14, 0.0 }
		},
	},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few pine
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 0.88,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_POPLAR" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.9
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.9
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.15,
						Max = 0.45
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
			{
			-- Create forest of Pine Trees
			DensityMap = "CONIFEROUS_DENSITY_MAP",
			Density = 0.98,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})